// SSE2
//
// CVTPS2PI mm, xmm ... xmm2̃pbNhPx_l
//                      mm2̃pbNht_u[hɕϊ
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( void )
{
    int i;
    float src[] = { 2007483647.0f, 3000000000.0f, 1.0f, 2.0f};
    int   dst[2] ;

    __asm
    {
        movdqu      xmm1, src
        cvtps2pi    mm1,  xmm1
        movq        dst,  mm1

        emms
    }

    for(i=0;i<4;i++)
        printf("src[%d]=%.2f  ", i, src[i]) ;
    printf("\n") ;
    for(i=0;i<2;i++)
        printf("dst[%d]=%d     ", i, dst[i]) ;
    printf("\n") ;
    for(i=0;i<2;i++)
        printf("dst[%d]=0x%08X     ", i, dst[i]) ;

    return 0;
}
