//
// SHUFPS xmm1,xmm2/m128, imm8
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <emmintrin.h>

int main( void )
{
    int i;
    __m128 src = _mm_setr_ps(  1.0f,  2.0f,  3.0f,  4.0f) ;
    __m128 dst = _mm_setr_ps( -1.0f, -2.0f, -3.0f, -4.0f) ;
    __m128 ans ;

    ans = _mm_shuffle_ps(dst, src, 0x55);

    printf("\nsrc = ") ;
    for(i=0;i<4;i++) printf("%4.1f  ", src.m128_f32[i]) ;
    printf("\ndst = ") ;
    for(i=0;i<4;i++) printf("%4.1f  ", dst.m128_f32[i]) ;
    printf("\n------------------------------") ;
    printf("\ndst = ") ;
    for(i=0;i<4;i++) printf("%4.1f  ", ans.m128_f32[i]) ;

    return 0;
}