//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

// MXCSRbit錾
typedef struct {
    unsigned    ie:1,
                de:1,
                ze:1,
                oe:1,
                ue:1,
                pe:1,
                :1,
                im:1,
                dm:1,
                zm:1,
                om:1,
                um:1,
                pm:1,
                rc:2,
                fz:1,
                :16;
} mxcsr_bits ;

union  {
    mxcsr_bits   bit ;
    unsigned int reg ;
} mxcsr ;


// MXCSR\
void dispMxcsr( void )
{
    printf("        tO(IE):%d\n",mxcsr.bit.ie);
    printf("    fm[}EtO(DE):%d\n",mxcsr.bit.de);
    printf("        [ZtO(ZE):%d\n",mxcsr.bit.ze);
    printf("I[o[t[EtO(OE):%d\n",mxcsr.bit.oe);
    printf("A_[t[EtO(UE):%d\n",mxcsr.bit.ue);
    printf("            xtO(PE):%d\n",mxcsr.bit.pe);
    printf("\n");

    printf("        }XN(IM):%d\n",mxcsr.bit.im);
    printf("    fm[}E}XN(DM):%d\n",mxcsr.bit.dm);
    printf("        [Z}XN(ZM):%d\n",mxcsr.bit.zm);
    printf("I[o[t[E}XN(OM):%d\n",mxcsr.bit.om);
    printf("A_[t[E}XN(UM):%d\n",mxcsr.bit.um);
    printf("            x}XN(PM):%d\n",mxcsr.bit.pm);
    printf("\n");

    printf("              ۂߐ(RC):%d\n",mxcsr.bit.rc);
    printf("      [EtbV(FZ):%d\n",mxcsr.bit.fz);
}

int main( int argc, char *argv[] )
{
	mxcsr.reg=0;

    mxcsr.bit.ie = 1;
    mxcsr.bit.de = 1;
    mxcsr.bit.ze = 1;
    mxcsr.bit.oe = 1;
    mxcsr.bit.ue = 1;
    mxcsr.bit.pe = 1;

    __asm   ldmxcsr  mxcsr.reg

    printf(" ---------- ύXO ---------- \n");
    dispMxcsr();


	mxcsr.reg=0;

    mxcsr.bit.im = 1;
    mxcsr.bit.dm = 1;
    mxcsr.bit.zm = 1;
    mxcsr.bit.om = 1;
    mxcsr.bit.um = 1;
    mxcsr.bit.pm = 1;

    __asm   ldmxcsr  mxcsr.reg


    printf("\n ---------- ύX ---------- \n");
    dispMxcsr();

    return 0;
}
