//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( int argc, char *argv[] )
{
    unsigned char src[] = {1,2,3,4,5,6,7,8};
    unsigned char msk[] = {0x80,0x01,0xFF,0x7F,0x81,0x70,0x91,0x00};
    unsigned char dst[] = {0,0,0,0,0,0,0,0};
    unsigned char* pDst=dst;
    int i;

    __asm
    {
        mov      edi, pDst

        movq     mm0, src
        movq     mm1, msk
        maskmovq mm0, mm1

        emms
    }

    printf("     src:");
    for(i=0;i<8;i++)
        printf(" %4d",src[i]);

    printf("\n    mask:");
    for(i=0;i<8;i++)
        printf(" 0x%02X",msk[i]);

    printf("\n    dest:");
    for(i=0;i<8;i++)
        printf(" %4d",dst[i]);

    return 0;
}