//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( int argc, char *argv[] )
{
    unsigned char src[] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
    unsigned char msk[] = {0x80,0x01,0xFF,0x7F,0x81,0x70,0x91,0x00,
                            0x80,0x01,0xFF,0x7F,0x81,0x70,0x91,0x00};
    unsigned char dst[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
    unsigned char* pDst=dst;
    int i;

    __asm
    {
        mov        edi, pDst

        movdqu     xmm0, src
        movdqu     xmm1, msk
        maskmovdqu xmm0, xmm1
    }

    printf("       src:");
    for(i=0;i<16;i++)
        printf(" %2d",src[i]);

    printf("\n mask(hex):");
    for(i=0;i<16;i++)
        printf(" %02X",msk[i]);

    printf("\n      dest:");
    for(i=0;i<16;i++)
        printf(" %2d",dst[i]);

    return 0;
}