// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( void )
{
    int i;
    short dst[] = {1, 2, 3, 4, 5, 6, 7, 8};
    short src[] = {9,10,11,12,13,14,15,16};
    short dstd[8];

    _asm
    {
        movdqu  xmm0,  dst
        movdqu  xmm1,  src
        phaddw  xmm0,  xmm1
        movdqu  dstd,  xmm0
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %2d", src[i]) ;
    printf(", dst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %2d", dst[i]) ;
    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %2d", dstd[i]) ;

    return 0;
}
