// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( void )
{
    int i;
    int dst[] = {1,2};
    int src[] = {3,4};
    int dstd[2];

    _asm
    {
        movq    mm0,  dst
        phaddd  mm0,  src
        movq    dstd, mm0

        emms
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %2d", src[i]) ;
    printf(", dst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %2d", dst[i]) ;
    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %2d", dstd[i]) ;

    return 0;
}
