// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( void )
{
    int i;
    short dst[] = { 32760,    7, 32767, 32767};
    short src[] = {-32760,   -8,-32767,-32767};
    short dstd[4];

    _asm
    {
        movq    mm0,  dst
        movq    mm1,  src
        phaddsw mm0,  mm1
        movq    dstd, mm0

        emms
    }

    printf("\nsrc =") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %7d", src[i]) ;
    printf(", dst=") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %7d", dst[i]) ;
    printf("\ndst'=") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %7d", dstd[i]) ;

    return 0;
}
