// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( void )
{
    int i;
    short dst[] = { 32760,    7,   256,-32767,-32760,   10,   200,-32767};
    short src[] = {-32760,   10,   200,-32767,-32760,   10,   200,-32767};
    short dstd[8];

    _asm
    {
        movdqu  xmm0,  dst
        movdqu  xmm1,  src
        phsubsw xmm0,  xmm1
        movdqu  dstd,  xmm0
    }

    printf("\nsrc =") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %8d", src[i]) ;
    printf("\ndst =") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %8d", dst[i]) ;
    printf("\ndst'=") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %8d", dstd[i]) ;

    return 0;
}
