// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    unsigned char dst[8] = {  0, 2, 8, 126, 127,  128,  129,  255};
    char          src[8] = {  0, 2, 8, 126, 127, -128, -127,   -1};
    short dstd[4];

    _asm
    {
        movq        mm0,  dst
        movq        mm1,  src
        pmaddubsw   mm0,  mm1
        movq        dstd, mm0

        emms
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %4d", src[i]) ;
    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %4d", dst[i]) ;
    printf("\n--------------------------------------------------") ;
    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf("  %7d", dstd[i]) ;

    return 0;
}