// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    char src[] = {1,-1,2,-2,126,-126,127,127};
    char dst[8] ;

    _asm
    {
        movq        mm0, src
        psignb      mm0, mm0
        movq        dst, mm0

        emms
    }

    printf("\n   src = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %4d", src[i]) ;

    printf("\nresult = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %4d", dst[i]) ;

    return 0;
}