// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    unsigned char src[] = { 1, 2, 3, 4, 5, 6, 7, 8};
    unsigned char dst[] = { 9,10,11,12,13,14,15,16};
    unsigned char dstd[8];

    _asm
    {
        movq        mm0,  src
        movq        mm1,  dst
        palignr     mm1,  mm0, 2
        movq        dstd, mm1

        emms
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %3d", src[i]) ;

    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %3d", dst[i]) ;

    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %3d", dstd[i]) ;

    return 0;
}