// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    unsigned char src[] = { 1, 2, 3, 4, 5, 6, 7, 8,
                            9,10,11,12,13,14,15,16};
    unsigned char dst[] = {17,18,19,20,21,22,23,24,
                           25,26,27,28,29,30,31,32};
    unsigned char dstd[16] ;

    _asm
    {
        movdqu      xmm0,  src
        movdqu      xmm1,  dst
        palignr     xmm1,  xmm0, 2
        movdqu      dstd,  xmm1
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %3d", src[i]) ;

    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %3d", dst[i]) ;

    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %3d", dstd[i]) ;

    return 0;
}