// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    short src[] = {1,-1,2,-2};
    short dst[4] ;

    _asm
    {
        pabsw       mm0, src
        movq        dst, mm0

        emms
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %4d", src[i]) ;

    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %4d", dst[i]) ;

    return 0;
}