//
// pgm.c
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                               Hiro KITAYAMA
//
#include <stdio.h>
#include <windows.h>

#define NUM_OF_LOOP     5

void main(void)
{
    UINT64 begin, finish, elapsed, total ;         // \\
    double clock;
    int i;

    Sleep(1);
    total=0;

    for( i = 0; i < NUM_OF_LOOP;i++ )
    {
        _asm
        {
            rdtsc
            mov     dword ptr [begin], eax
            mov     dword ptr [begin+4], edx
        }

        Sleep(1000);

        _asm
        {
            rdtsc
            mov     dword ptr [finish], eax
            mov     dword ptr [finish+4], edx
        }
        elapsed = finish > begin ? finish - begin : begin - finish ;
        total+=elapsed;
        //printf( "counter= %I64u\n", elapsed ) ;
    }
    total /= NUM_OF_LOOP;
    clock=total/(double)1000000000;
    printf("%2.4lf[GHz]\n", clock );
}