//
// effectC.c
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                               Hiro KITAYAMA
//
#include <windows.h>
#include <math.h>



//---------------------------------------------------------------------------
//
// GtFNg
//
//      0  -1   0   /
//  (  -1   0   1  /  4  )  + 128
//      0   1   0 /
//
void effectC( LPBYTE pAligned[], LONG width, LONG height, int alpha )
{
    LPBYTE  lpSrc = pAligned[1] ;
    LPBYTE  lpDst = pAligned[0] ;
    int     x, y;
    float   fResult;
    float mulMask[3][3] ={  0.0f, -1.0f,  0.0f,
                           -1.0f,  0.0f,  1.0f,
                            0.0f,  1.0f,  0.0f
    };

    for( y = 0 ; y < height-2 ; y++ )
    {
        for( x = 0 ; x < width-2 ; x++ )
        {
            fResult =
                (float)*(lpSrc+((width*(y+0))+(x+0))*4) * mulMask[0][0]
                            + (float)*(lpSrc+((width*(y+0))+(x+1))*4) * mulMask[0][1]
                                + (float)*(lpSrc+((width*(y+0))+(x+2))*4) * mulMask[0][2]

                       + (float)*(lpSrc+((width*(y+1))+(x+0))*4) * mulMask[1][0]
                            + (float)*(lpSrc+((width*(y+1))+(x+1))*4) * mulMask[1][1]
                                + (float)*(lpSrc+((width*(y+1))+(x+2))*4) * mulMask[1][2]

                       + (float)*(lpSrc+((width*(y+2))+(x+0))*4) * mulMask[2][0]
                            + (float)*(lpSrc+((width*(y+2))+(x+1))*4) * mulMask[2][1]
                                + (float)*(lpSrc+((width*(y+2))+(x+2))*4) * mulMask[2][2];

            fResult/=4.0f;
            fResult+=128.0f;
            fResult=min( max( fResult, 0 ), 255 );

            *(lpDst+((width*(y+1)+(x+1))*4)+0) = (BYTE)fResult;
            *(lpDst+((width*(y+1)+(x+1))*4)+1) = (BYTE)fResult;
            *(lpDst+((width*(y+1)+(x+1))*4)+2) = (BYTE)fResult;
            *(lpDst+((width*(y+1)+(x+1))*4)+3) = (BYTE)0;
        }
    }
}
