//
// effectSimd.cpp
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                               Hiro KITAYAMA
//
#include <windows.h>


//---------------------------------------------------------------------------
//
// GtFNg,SIMD
//
void effectSimd( LPBYTE pAligned[], LONG width, LONG height )
{
    LPBYTE  lpSrc = pAligned[1] ;
    LPBYTE  lpDst = pAligned[0] ;

    _asm
    {
        xor     ebx, ebx
        mov     esi, lpSrc         ; esi = src
        mov     edi, lpDst         ; edi = dst

        mov     ecx, width
        shr     ecx, 2
        mov     eax, height
        mul     ecx
        mov     ecx, eax            ; num of loop

        pxor    xmm1,xmm1

    loopLabel:
        movdqa  xmm0, [esi+ebx]

        pavgb   xmm0,  xmm1         ; Y= 1/2

        movdqa  [edi+ebx], xmm0
        lea     ebx,  [ebx+16]

        dec   ecx
        jnz   loopLabel
    }
}
