//
// UNPCKHPS xmm1,m128
//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <emmintrin.h>

int main( void )
{
    int i;
    __m128 src = _mm_setr_ps( 1.0f,  2.0f,  3.0f,  4.0f) ;
    float dst[] = { -1.0f, -2.0f, -3.0f, -4.0f} ;
    float ans[4] ;

    __asm
    {
        movdqu      xmm2, dst
        unpckhps    xmm2, src
        movdqu      ans,  xmm2
    }

    printf("\nsrc = ") ;
    for(i=3;i>=0;i--) printf("%4.1f  ", src.m128_f32[i]) ;
    printf("\ndst = ") ;
    for(i=3;i>=0;i--) printf("%4.1f  ", dst[i]) ;
    printf("\n------------------------------") ;
    printf("\ndst = ") ;
    for(i=3;i>=0;i--) printf("%4.1f  ", ans[i]) ;

    return 0;
}