//
// SHUFPD xmm1,xmm2/m128, imm8
//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

int main( void )
{
    int i;
    double src[] = {  1.0f,  2.0f} ;
    double dst[] = { -1.0f, -2.0f} ;
    double ans[4] ;

    __asm
    {
        movdqu  xmm1, src
        movdqu  xmm2, dst
        shufpd  xmm2, xmm1, 002h
        movdqu  ans,  xmm2
    }

    printf("\nsrc = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", src[i]) ;
    printf("\ndst = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", dst[i]) ;
    printf("\n------------------------------") ;
    printf("\ndst = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", ans[i]) ;

    return 0;
}