//
// UNPCKHPD xmm1,xmm2/m128
//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <emmintrin.h>

int main( void )
{
    int i;
    __m128d src = _mm_setr_pd( 1.0f,  2.0f) ;
    double dst[] = { -1.0f, -2.0f} ;
    double ans[4] ;

    __asm
    {
        movdqu      xmm1, dst
        unpcklpd    xmm1, src
        movdqu      ans,  xmm1
    }

    printf("\nsrc = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", src.m128d_f64[i]) ;
    printf("\ndst = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", dst[i]) ;
    printf("\n------------------------------") ;
    printf("\ndst = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", ans[i]) ;

    return 0;
}