//
// UNPCKHPD xmm1,xmm2/m128
//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <emmintrin.h>

int main( void )
{
    int i;
    __m128d src = _mm_setr_pd(  1.0f,  2.0f) ;
    __m128d dst = _mm_setr_pd( -1.0f, -2.0f) ;
    __m128d ans ;

    ans = _mm_unpacklo_pd(dst, src );

    printf("\nsrc = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", src.m128d_f64[i]) ;
    printf("\ndst = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", dst.m128d_f64[i]) ;
    printf("\n------------------------------") ;
    printf("\ndst = ") ;
    for(i=1;i>=0;i--) printf("%4.1lf  ", ans.m128d_f64[i]) ;

    return 0;
}