//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>


//------------------------------------------------------
// get counter
long long getCurCounter(void)
{
    long long  counter ;         // \\

    _asm
    {
        rdtsc
        mov     dword ptr [counter+0], eax
        mov     dword ptr [counter+4], edx
    }

    return counter;
}

//------------------------------------------------------
// main
int main( int argc, char *argv[] )
{
    long long begin, finish, elapsed1,elapsed2 ;    // \\
    __declspec(align(16)) float src[4]={0,0,0,0};

    // movntps -------------------------
    begin = getCurCounter();
    __asm
    {
        mov     ecx, 100000

    loop1:
		movaps  xmm0, src
        clflush	byte ptr[src]
        movntps src,  xmm0
        loop    loop1
    }
    finish = getCurCounter();
    elapsed1 = finish > begin ? finish - begin : begin - finish ;

    printf("clflush    = %I64u clocks.\n", elapsed1 ) ;



    // movaps -------------------------
    begin = getCurCounter();
    __asm
    {
        mov     ecx, 100000

    loop2:
		movaps  xmm0, src
        nop
        movntps src,  xmm0
        loop    loop2
    }
    finish = getCurCounter();
    elapsed2 = finish > begin ? finish - begin : begin - finish ;

    printf("no clflush = %I64u clocks.\n\n", elapsed2 ) ;

    printf("%2.3f times faster.\n", (double)elapsed1/(double)elapsed2 ) ;

    return 0;
}