//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    double src[2];
	__declspec(align(16)) double dst[2]={0,0};
    int i;

    if( argc != 3 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    for(i=0;i<2;i++)
        src[i] = strtod(argv[2-i],NULL);

    __asm
    {
        movupd      xmm0, src
        movntpd     dst,  xmm0
    }

    printf("     source: %12.4f, %12.4f\n",src[1], src[0]);
    printf("     result: %12.4f, %12.4f\n",dst[1], dst[0]);

    return 0;
}