// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( void )
{
    int i;
    short dst[] = { 1, 2, 8, 4, 6, 7,11, 8};
    __declspec(align(16))
    short src[] = { 1,10,11, 2,13, 4, 5,16};
    short dstd[8];

    _asm
    {
        movdqu  xmm0,  dst
        phsubw  xmm0,  src
        movdqu  dstd,  xmm0
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %3d", src[i]) ;
    printf(", dst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %3d", dst[i]) ;
    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %3d", dstd[i]) ;

    return 0;
}