// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( void )
{
    int i;
    int dst[] = { 1,  7,  9,  3};
    __declspec(align(16))  int src[] = {11, 22, 23, 10};
    int dstd[4];

    _asm
    {
        movdqu  xmm0,  dst
        phsubd  xmm0,  src
        movdqu  dstd,  xmm0
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %3d", src[i]) ;
    printf(", dst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %3d", dst[i]) ;
    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %3d", dstd[i]) ;

    return 0;
}