// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    unsigned char dst[] = { 0, 2, 8, 126, 127,  128,  129,  255,
                             0, 2, 8, 126, 127,  128,  129,  255};
    char          src[] = { 0, 2, 8, 126, 127, -128, -127,   -1,
                              0, 2, 8, 126, 127, -128, -127,   -1};
    short dstd[8];

    _asm
    {
        movdqu      xmm0,  dst
        movdqu      xmm1,  src
        pmaddubsw   xmm0,  xmm1
        movdqu      dstd,  xmm0
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %3d", src[i]) ;
    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %3d", dst[i]) ;
    printf("\n-----------------------------------") ;
    printf("-------------------------------------") ;
    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %7d", dstd[i]) ;

    return 0;
}