// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    short dst[] = { 255,  32767,    -7, -32768,
                     255,  32767,    -7, -32768};
    __declspec(align(16))
    short src[] = { 256, -32768, 32767,  32767,
                     256, -32768, 32767,  32767};
    short dstd[8];

    _asm
    {
        movdqu      xmm0,  dst
        pmulhrsw    xmm0,  src
        movdqu      dstd,  xmm0
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %7d", src[i]) ;
    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %7d", dst[i]) ;
    printf("\ndst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %7d", dstd[i]) ;

    return 0;
}