// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    unsigned char src[] = {0x00,0x00,0x00,0x01,0x80,0xFF,0x07,0x07,
                            0x08,0x08,0x08,0x09,0x99,0xEE,0x0F,0x0F};
    unsigned char dst[] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,
                            0x09,0x10,0x11,0x12,0x13,0x14,0x15,0x16};
    unsigned char desd[16] ;

    _asm
    {
        movdqu      xmm0,  dst
        movdqu      xmm1,  src
        pshufb      xmm0,  xmm1
        movdqu      desd,  xmm0
    }

    printf("\n src = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %02X", src[i]) ;
    printf("\n dst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %02X", dst[i]) ;
    printf("\n dst'= ") ;
    for(i=(sizeof(desd)/sizeof(desd[0]))-1;i>=0;i--)
        printf(" %02X", desd[i]) ;

    return 0;
}