// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    __declspec(align(16))
    int src[] = { 1, -1,  0,  1};
    int dst[] = {-1, -2, -3, -4};
    int dstd[4] ;

    _asm
    {
        movdqu      xmm1,  dst
        psignd      xmm1,  src
        movdqu      dstd,  xmm1
    }

    printf("\n   src = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %3d", src[i]) ;
    printf("\n   dst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %3d", dst[i]) ;

    printf("\n   dst'= ") ;
    for(i=(sizeof(dstd)/sizeof(dstd[0]))-1;i>=0;i--)
        printf(" %3d", dstd[i]) ;

    return 0;
}