// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    char src[] = { -1,  2, -3,  4, -5,  6, -7,  8,
                   -9, 10,-11, 12,-13, 14,-15, 16};
    char dst[16] ;

    _asm
    {
        movdqu      xmm0,  src
        pabsb       xmm1,  xmm0
        movdqu      dst,   xmm1
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %3d", src[i]) ;

    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %3d", dst[i]) ;

    return 0;
}