// SSSE3
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>

int main( int argc, char *argv[] )
{
    int i;
    short src[] = { -1,  2, -3,  4, -5,  6, -7,  8};
    short dst[8] ;

    _asm
    {
        movdqu      xmm0,  src
        pabsw       xmm1,  xmm0
        movdqu      dst,   xmm1
    }

    printf("\nsrc = ") ;
    for(i=(sizeof(src)/sizeof(src[0]))-1;i>=0;i--)
        printf(" %4d", src[i]) ;

    printf("\ndst = ") ;
    for(i=(sizeof(dst)/sizeof(dst[0]))-1;i>=0;i--)
        printf(" %4d", dst[i]) ;

    return 0;
}