//
// 4 x 4 ZƑa
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

void horiz_add4x4(float *src, float *dst, float* sum)
{
    __asm
    {
        mov     ecx, src            ; \[XAhX̃[h
        mov     edx, dst            ; fXeBl[VAhX̃[h

        movups  xmm0, [ecx]         ; xmm0 = A1 A2 A3 A4
        movups  xmm1, [ecx+16]      ; xmm1 = B1 B2 B3 B4
        movups  xmm2, [ecx+32]      ; xmm2 = C1 C2 C3 C4
        movups  xmm3, [ecx+48]      ; xmm3 = D1 D2 D3 D4


        movaps  xmm5, xmm0          ; xmm5 = A1,A2,A3,A4
        movlhps xmm5, xmm1          ; xmm5 = A1,A2,B1,B2
        movhlps xmm1, xmm0          ; xmm1 = A3,A4,B3,B4
        addps   xmm5, xmm1          ; xmm5 = A1+A3,A2+A4,B1+B3,B2+B4
        movaps  xmm4, xmm2
        movlhps xmm2, xmm3          ; xmm2 = C1,C2,D1,D2
        movhlps xmm3, xmm4          ; xmm3 = C3,C4,D3,D4
        addps   xmm3, xmm2          ; xmm3 = C1+C3,C2+C4,D1+D3,D2+D4
        movaps  xmm6, xmm5          ; xmm6 = A1+A3,A2+A4,B1+B3,B2+B4

        shufps  xmm6, xmm3, 0x88    ; xmm6 = A1+A3,B1+B3,C1+C3,D1+D3

        shufps  xmm5, xmm3, 0xdd    ; xmm5 = A2+A4,B2+B4,C2+C4,D2+D4

        addps   xmm6, xmm5          ; xmm6= D,C,B,A


        movups  [edx], xmm6

        haddps  xmm6, xmm6          ; D+C,B+A,D+C,B+A
        haddps  xmm6, xmm6          ; D+C+B+A,D+C+B+AG,D+C+B+A,D+C+B+AG

        mov     edx, sum
        movd    [edx], xmm6
    }
}

// main
int main( void )
{
    int i;
    float src[] = {   1,   2,   3,   4,
                      5,   6,   7,   8,
                      9,  10,  11,  12,
                     13,  14,  15,  16
    };
    float dst[] = {   0,   0,   0,   0};
    float sum=0;

    horiz_add4x4( src, dst, &sum);

    printf("\n<<<<ADD 4x4 >>>>\n") ;
    printf("--dst ------ src -------- ") ;
    for(i=0;i<(sizeof(src)/sizeof(src[0]));i++)
    {
        if( 0 == i % 4 )
             printf("\n %3.0f = ", dst[i/4]);
        printf(" %2.0f", src[i]) ;
    }
     printf("\nsum = %4.0f", sum) ;

    return 0;
}