//---------------------------------------------------------------------------
//
// (C)Copyright Spacesoft corp., 2007 All rights reserved.
//                               Hiro KITAYAMA
//
// NX̃wb_
//

//---------------------------------------------------------------------------
#ifndef spCbmpH
#define spCbmpH

#define SAFE_DELETE(p)          if(p) { delete(p);         p=NULL ; }
#define SAFE_FREE(p)            if(p) { free(p);           p=NULL ; }
#define SAFE_ALIGNED_FREE(p)    if(p) { _aligned_free(p);  p=NULL ; }


//---------------------------------------------------------------------------
class Cbmp
{
private:
    // ----- private method -------------------------------------------------
    BITMAPFILEHEADER    bmFileHdr ;         // wb_
    PBITMAPINFOHEADER   pDib ;              // DIBւ̃|C^
    LPBYTE              pBitmap ;           // rbg}bv{̂ւ̃|C^
    char bmpFName[256] ;                    // rbg}bvt@C

    bool readHeader( FILE* fp, PBITMAPFILEHEADER bmFileHdr ) ;
    bool readBody( FILE* fp, PBITMAPFILEHEADER bmFileHdr,
                                                PBITMAPINFOHEADER pDib ) ;


public:
    // ----- Constructor/Destructor -----------------------------------------
    Cbmp( void ) ;                          // RXgN^
    ~Cbmp( void ) ;                         // fXgN^

    // ----- public method --------------------------------------------------
    bool getFname( char* inFname ) ;        // t@C擾
    void extFname( char* inFName ) ;        // t@CpX
    bool LoadFromFile( char* bmpFName ) ;   // rbg}bvt@C̓ǂݍ
    unsigned int getWidth( void ) ;         // rbg}bv̕擾
    unsigned int getHeight( void ) ;        // rbg}bv̍擾
    PBITMAPINFOHEADER getPdib( void ) ;     // rbg}bvwb_̃|C^擾
    LPBYTE getPbitmapBody( void ) ;         // rbg}bv{̂̃|C^擾
    bool is24bit( void ) ;                  // 24rbgErbg}bvf
    bool is32bit( void ) ;                  // 32rbgErbg}bvf

};

//---------------------------------------------------------------------------
#endif
