//
// effectAsm.cpp
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                               Hiro KITAYAMA
//
#include <windows.h>


//---------------------------------------------------------------------------
//
// GtFNg,ASM
//
void effectAsm( LPBYTE pAligned[], LONG width, LONG height )
{
    LPBYTE  lpSrc = pAligned[1] ;
    LPBYTE  lpDst = pAligned[0] ;

    //---------------------------------------------------
    _asm
    {
          cld

          mov     ecx, width          ; 
          shl     ecx, 2              ;  x 4
          mov     eax, height         ; c
          mul     ecx
          mov     ecx, eax

          mov     ebx, lpSrc          ; 擪AhX
          mov     edx, lpDst          ; 擪AhX

      loopLabel:
          mov     al, byte ptr[ebx]
          shr     al, 1               ; Y = 1/2
          mov     byte ptr[edx], al
          inc     ebx
          inc     edx

          dec     ecx
          jnz     loopLabel
    }
}
